%=======================================================================
%
%              Blok odpowiadajacy za wykonanie estymacji
%
%=======================================================================

rozmiar=size(film);

ry0 =  rozmiar(1)/2;
ry = rozmiar(1)/2;
rx0 = rozmiar(2)/2; 
rx = rozmiar(2)/2;

% =========== Zdefiniuj suwak postepu pracy ==============
idpo=uicontrol(gcf,'style','slider','position' , [320 255 200 20] ,...
             'max',100,'min',0,'value',0);
idpo1=uicontrol('style','text','position' , [385 275 20 15] ,...
             'string', '0');
uicontrol('style','text','position' , [405 275 15 15] ,...
             'string', '%');
         
% ======== Zdefiniuj zmienne do estymacji ruchu ============
dxx = [];
dyy = [];

suma=[];

for i=1:rozmiar(3)-1
    
    roznicap =imabsdiff(film(:,:,i+1), film(:,:,i));
    
% ======= Estymata w postaci wykresu liczbowego ===========
    suma= [suma sum(sum(roznicap))/10000];
    G1_sprzezone = conj(fft2(double(medfilt2(film(:,:,i)))));
    
% ======= Filtr medianowy i mnozenie obrazow ===============
    XXX = ((fft2(double(medfilt2(film(:,:,i+1)))).*G1_sprzezone))./(abs(fft2(double(medfilt2(film(:,:,i+1))).*G1_sprzezone)));

    YYY = ifft2(double(XXX));

    ZZZ = abs(YYY);
    ZZZ(1,1) = 0;
    [w, ghjk] = max(max(ZZZ));

    if ghjk < rozmiar(2)/2 
        dxx(i) = ghjk;
    else
        dxx(i) = ghjk - rozmiar(2)-1;
    end
    [wx, ixxx] = max(ZZZ);
    [wxx,ixxxx]=max(wx);
    ixxxxx=ixxx(ixxxx);
    if ixxxxx >= rozmiar(1)/2
        dyy(i) =  rozmiar(1) -ixxxxx +1;
    else
        dyy(i) = -ixxxxx+1;
    end
    set(idpo,'value', 100/(rozmiar(3)-1)*i);
    set(idpo1,'string',num2str(round(i/(rozmiar(3)-1)*100)));
end

figure(5),cla,grid,plot([1:1:rozmiar(3)-1],suma),xlabel('klatki'),title('Modul z roznicy dwoch kolejnych klatek')

figure(6),cla,grid,title('Mapa przesuniec'),xlabel('piksele x'),ylabel('piksele y')

for i=1:rozmiar(3)-1
    
    rx0 = rx0 + dxx(i);
    ry0 = ry0 + dyy(i);
    rx = [rx, rx0]; ry = [ry , ry0];
    line(rx,ry,'color','magenta');
    axis([0, rozmiar(2), 0, rozmiar(1)]); 
    pause(0.05);
end


