%=======================================================================
%
%              Estymacja ruchu metoda korelacji fazowej ver. 1.0 Current
%                                          Glowna czesc programu
%                         Done by Emil Grochocki, Zbigniew Rydel 2004
%
%=======================================================================


%=======================================================================
%                                        Przygotuj srodowisko
%=======================================================================
clear;
film = [];
clf;
figure(1)

%=======================================================================
%                                                (OKIENKO 1)
%                                                Wybor filmu
%=======================================================================

% ==================== Definicja okienka 1 =================================
 uicontrol('Style' , 'frame' , 'position' , [20 240 250 155] ); 

 % =============== Definiuj i ustaw pozycje napisu Krok  ======================
    uicontrol('Style' , 'text' , 'position' , [100 400 60 20] ,...
        'string', 'Krok 1:');
    
 % =============== Definiuj i ustaw pozycje napisu Wybierz film  ================
    uicontrol('Style' , 'text' , 'position' , [60 370 120 20] ,...
        'string', 'Prosze wybrac film:');
    
  % =============== Definiuj i ustaw pozycje opisu  ============================
    uicontrol('Style' , 'text' , 'position' , [60 275 150 65] ,...
        'string', 'INFORMACJA: W tym etapie nastepuje wczytanie filmu oraz konwersja klatek RGB na odpowiadajace im obrazy w odcieniach szaroi. ');
   
    hpop = uicontrol('Style', 'popup',...
       'String', 'Wielokat|Wielokat zaszumiony|Wielokaty i okrag|Ruch kamery|Swiatla',...
       'Position', [60 320 150 50],...
       'Callback', 'wybor');
    
   %=======================================================================
   %                                                  (OKIENKO 2)
   %                  Znajdywanie mapy przesuniec metoda korelacji fazowej  
   %=======================================================================
   
   % =============== Definicja okienka 2 ======================================
       uicontrol('Style' , 'frame' , 'position' , [300 240 245 155] );      
   
   % =============== Definicja ramki i napisu etap 2 ============================
       uicontrol('Style' , 'text' , 'position' , [380 398 60 20] ,...   
       'string', 'Krok 2:');
   
   % =============== Tekst w okienku 2 =======================================
    uicontrol('Style' , 'text' , 'position' , [340 265 150 80] ,... 
        'string', 'INFORMACJA: Etap ten zezwala na odnajdywanie mapy przesuniec metoda korelacji fazowej. '); 
   
    uicontrol('style','pushbutton',...
          'position',[350 360 120 20],...
          'string', 'Dokonaj estymacji',...
          'callback','estymuj');
  
   %=======================================================================
   %                                                  (OKIENKO 3)
   %                                            Odejmowanie klatek  
   %=======================================================================
  
   % =============== Definicja okienka 3 =======================================
  uicontrol('Style' , 'frame' , 'position' , [19 32 252 157] ); 

   % =============== Definicja ramki i napisu odejmowanie klatek =================
   uicontrol('Style' , 'text' , 'position' , [60 190 160 20] ,...
        'string', 'Odejmowanie klatek. '); 
  
   % =================== Definicja ramki i napisu  ==============================
   uicontrol('Style' , 'text' , 'position' , [60 155 160 20] ,...
        'string', 'Prosze wpisac numer klatki: '); 
 
   % ================= Tekst w okienku 3 ======================================
   uicontrol('Style' , 'text' , 'position' , [50 50 160  40] ,...
        'string', 'INFORMACJA: W tym etapie jest obliczana roznica dwoch kolenych klatek a takze roznica miedzy klatka przesunieta i estymowana. '); 
   
    % ============ Definiuj okienko do wpisania numeru klatki ====================
    hedit =uicontrol('style','edit','position',[115 130 45 20]);
    
    % ============ Definiuj przycisk z napisem wykonaj ===========================
    uicontrol('style','pushbutton',...
          'position',[90 100 90 20],...
          'string', 'Wykonaj operacje',...
      'callback','odejmuj');

    %=======================================================================
    %                                                  (OKIENKO 4)
    %                                            Korelacja obrazow  
    %=======================================================================

    % =============== Definicja okienka 4 ======================================
    uicontrol('Style' , 'frame' , 'position' , [300 33 245 155] ); 
    
    % =============== Definicja ramki i napisu Korelacja obrazow ==================
    uicontrol('Style' , 'text' , 'position' , [340 190 160 20] ,...
        'string', 'Korelacja obrazw. '); 
    
     % =============== Definiuj polozenie i tresc tekstu Prosze wpisac ... ============ 
     uicontrol('Style' , 'text' , 'position' , [320 155 195 20] ,...
        'string', 'Prosze wpisac nr klatki 1 oraz nr klatki 2: '); 

     % ===============   Definiuj pola na wpisanie klatek ==========================
     hedit1 =uicontrol('style','edit','position',[370 130 45 20]);
     hedit2 =uicontrol('style','edit','position',[420 130 45 20]);

     % ===============  Tekst w okienku 4 =======================================
     uicontrol('Style' , 'text' , 'position' , [335 50 160  40] ,...
        'string', 'INFORMACJA: W tym etapie nastepuje obliczenie korelacji pomiedzy dwoma wybranymi obrazami. '); 
    
     % ============ Definiuj przycisk z napisem wykonaj ===========================
     uicontrol('style','pushbutton',...
          'position',[372 100 90 20],...
          'string', 'Dokonaj korelacji',...
      'callback','koreluj');
     % ========================================================================
 
    
    
    
 
  

  

